// DaaDoc.cpp : implementation of the CDaaDoc class
//

#include "stdafx.h"

#include "Daa.h"

#include "DaaDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDaaDoc

IMPLEMENT_DYNCREATE(CDaaDoc, CDocument)

BEGIN_MESSAGE_MAP(CDaaDoc, CDocument)
	//{{AFX_MSG_MAP(CDaaDoc)
	ON_COMMAND(ID_FILE_SAVE_BMP, OnFileSaveBmp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDaaDoc construction/destruction

CDaaDoc::CDaaDoc()
{
	// //TODO: add one-time construction code here

}

CDaaDoc::~CDaaDoc()
{
}

BOOL CDaaDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// //TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CDaaDoc serialization



void CDaaDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		DAA_Save(ar);
	}
	else
	{
		DAA_Load(ar);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CDaaDoc diagnostics

#ifdef _DEBUG
void CDaaDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CDaaDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDaaDoc commands


BOOL CDaaDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
	

    //CFile* pfile = GetFile(lpszPathName, CFile::modeReadWrite);
    //pfile->Close();
	// //TODO: Add your specialized creation code here
	
	return TRUE;
}



///////////////////////////////////////////////////////////////
// SAVE BITMAP                                               //
///////////////////////////////////////////////////////////////
  
LPBITMAPINFO CreateBitmapInfoStruct(CBitmap &b)
{ 
    BITMAP bmp; 
    LPBITMAPINFO lpbmi; 
    int    cClrBits; 
 
    b.GetBitmap(&bmp);
    cClrBits = bmp.bmPlanes * bmp.bmBitsPixel;
 
    if (cClrBits == 1) 
        cClrBits = 1; 
    else if (cClrBits <= 4) 
        cClrBits = 4; 
    else if (cClrBits <= 8) 
        cClrBits = 8; 
    else if (cClrBits <= 16) 
        cClrBits = 16; 
    else if (cClrBits <= 24) 
        cClrBits = 24; 
    else 
        cClrBits = 32; 
 
 
    //if (cClrBits != 24)
    if (cClrBits < 16) 
        lpbmi = (LPBITMAPINFO) new BYTE[sizeof(BITMAPINFOHEADER) + 
                 sizeof(RGBQUAD) * (2^cClrBits)];
          
    // There is no RGBQUAD array for the 24-bit-per-pixel format. 
    else 
        cClrBits = 24;
        lpbmi = (LPBITMAPINFO) new BYTE[sizeof(BITMAPINFOHEADER)];
          
 
    /* Initialize the fields in the BITMAPINFO structure. */ 
    lpbmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER); 
    lpbmi->bmiHeader.biWidth = bmp.bmWidth; 
    lpbmi->bmiHeader.biHeight = bmp.bmHeight; 
    lpbmi->bmiHeader.biPlanes = bmp.bmPlanes; 
    //lpbmi->bmiHeader.biBitCount = bmp.bmBitsPixel;
    lpbmi->bmiHeader.biBitCount = (WORD) cClrBits;
    
    if (cClrBits < 24) lpbmi->bmiHeader.biClrUsed = 2^cClrBits;
    else lpbmi->bmiHeader.biClrUsed = 0;
 
    /* If the bitmap is not compressed, set the BI_RGB flag. */ 
 
    lpbmi->bmiHeader.biCompression = BI_RGB; 
 
    /* 
     * Compute the number of bytes in the array of color 
     * indices and store the result in biSizeImage. 
     */ 
 
    lpbmi->bmiHeader.biSizeImage = (lpbmi->bmiHeader.biWidth + 7) /8 
                                    * lpbmi->bmiHeader.biHeight 
                                    * cClrBits; 
 
    lpbmi->bmiHeader.biClrImportant = 0; 
    lpbmi->bmiHeader.biXPelsPerMeter = 0;
    lpbmi->bmiHeader.biYPelsPerMeter = 0;
    
    return lpbmi;  
} 
 


void CreateBMPFile(CString path, CBitmap &bmp) 
{ 
    LPBITMAPINFO lpbi = CreateBitmapInfoStruct(bmp);
    LPBITMAPINFOHEADER lpbih = LPBITMAPINFOHEADER(lpbi);
    LPBYTE lpBits = new BYTE[lpbih->biSizeImage];

    //bmp.GetObject
    //bmp.bmPlanes * bmp.bmBitsPixel

    BITMAP b;
    bmp.GetBitmap(&b);
    
    //int nbytes = b.bmWidthBytes * b.bmHeight;

    CDC dc;
    dc.CreateCompatibleDC(NULL);
    //CBitmap* bmpold = dc.SelectObject(&bmp);

    GetDIBits(dc.m_hDC, HBITMAP(bmp), 0, (WORD) lpbih->biHeight, 
                   NULL, lpbi, DIB_RGB_COLORS);
    GetDIBits(dc.m_hDC, HBITMAP(bmp), 0, (WORD) lpbih->biHeight, 
                   lpBits, lpbi, DIB_RGB_COLORS);
    //
    //bmp.GetBitmapBits(nbytes, lpBits);


    BITMAPFILEHEADER hdr;
    hdr.bfType = 'MB';     
    
    hdr.bfReserved1 = 0; 
    hdr.bfReserved2 = 0; 
 
    hdr.bfSize = (DWORD) (sizeof(BITMAPFILEHEADER) + 
                 lpbih->biSize + lpbih->biClrUsed 
                 * sizeof(RGBQUAD) + lpbih->biSizeImage); 
    // Compute the offset to the array of color indices.  
    hdr.bfOffBits = (DWORD) sizeof(BITMAPFILEHEADER) + 
                    lpbih->biSize + lpbih->biClrUsed 
                    * sizeof (RGBQUAD);
    
    
    CFile file(path, CFile::modeCreate | CFile::modeWrite);
    
    file.Write(&hdr, sizeof(BITMAPFILEHEADER));
   
    file.Write(lpbih,
               sizeof(BITMAPINFOHEADER) + lpbih->biClrUsed * sizeof (RGBQUAD));
    
   

    file.Write(lpBits, lpbih->biSizeImage);

    delete lpbi;
    delete lpBits;
    //dc.SelectObject(bmpold); 
} 
 

// ------------------------------- CFileDialog Crashes in Windows95 compatibility
void CDaaDoc::OnFileSaveBmp() 
{
	CFileDialog *pDlg = new CFileDialog(FALSE,
									    "BMP",
									    "Untitled.BMP", 
									    OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
										"*.BMP|*.BMP||",
										0);

    pDlg->m_ofn.lpstrTitle = "Save display As...";
    if (pDlg->DoModal() == IDOK)
    {
        CString s = pDlg->GetPathName();
        CString e = s.Right(4);
        e.MakeUpper();
		if (e == ".BMP") CreateBMPFile(s, *DAA_GetDisplayBitmap());
    }

    if (pDlg)
	{
		delete pDlg;
		pDlg = NULL;
	}
}


