
#ifndef INC_MEMORYMAPPEDFILE
#define INC_MEMORYMAPPEDFILE

// =====================================================================================
//   CLASS MemoryMappedFile
// ======================================================================================
class MemoryMappedFile
{
	private:
		HANDLE		FileHandle;
		void*		MappingAddress;
		__int32		FileLength;
		char*		functionReturnValue;

	public:
		MemoryMappedFile(LPCSTR Filename, __int32 Length);
		~MemoryMappedFile();

	private:
		void Destroy();

	public:

		// ---------------------------------------------------------------- String
		void WriteString(__int32 Offset, LPSTR Text);
		LPSTR ReadString(__int32 Offset);

		// ---------------------------------------------------------------- Int32
		void WriteInt32(__int32 Offset, __int32 Value);
		__int32 ReadInt32(__int32 Offset);

		// ---------------------------------------------------------------- Single
		void WriteSingle(__int32 Offset, float Value);
		float ReadSingle(__int32 Offset);

		// ---------------------------------------------------------------- Double
		void WriteDouble(__int32 Offset, double Value);
		double ReadDouble(__int32 Offset);

};

#endif

