// DaaView.cpp : implementation of the CDaaView class
//

#include "stdafx.h"
#include "Daa.h"

#include "DaaDoc.h"
#include "DaaView.h"

#include "Daa.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDaaView

IMPLEMENT_DYNCREATE(CDaaView, CView)

BEGIN_MESSAGE_MAP(CDaaView, CView)
	//{{AFX_MSG_MAP(CDaaView)
	ON_WM_CREATE()
	//
	ON_WM_SIZE()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_MOUSEMOVE()
	ON_WM_MOUSEWHEEL()
	ON_WM_KEYDOWN()
	//
	ON_COMMAND(ID_VIEW_SPECTRUM3D, OnViewSpectrum3d)
	ON_UPDATE_COMMAND_UI(ID_VIEW_SPECTRUM3D, OnUpdateViewSpectrum3d)
	ON_COMMAND(ID_VIEW_SETREFERENCE, OnViewSetreference)
	ON_UPDATE_COMMAND_UI(ID_VIEW_SETREFERENCE, OnUpdateViewSetreference)
	ON_COMMAND(ID_HELP_HELP, OnHelpHelp)
	ON_UPDATE_COMMAND_UI(ID_VIEW_MULTIDRAW, OnUpdateViewMultidraw)
	ON_COMMAND(ID_VIEW_MULTIDRAW, OnViewMultidraw)
	//
	ON_COMMAND(ID_BW_MAX, OnBwMax)
	ON_COMMAND(ID_BW_30, OnBw30)
	ON_COMMAND(ID_BW_10, OnBw10)
	ON_COMMAND(ID_BW_3, OnBw3)
	ON_COMMAND(ID_BW_1, OnBw1)
	ON_UPDATE_COMMAND_UI(ID_BW_MAX, OnUpdateBwMax)
	ON_UPDATE_COMMAND_UI(ID_BW_30, OnUpdateBw30)
	ON_UPDATE_COMMAND_UI(ID_BW_10, OnUpdateBw10)
	ON_UPDATE_COMMAND_UI(ID_BW_3, OnUpdateBw3)
	ON_UPDATE_COMMAND_UI(ID_BW_1, OnUpdateBw1)
	//
	ON_COMMAND(ID_FHT_WIN_0, OnFhtWin0)
	ON_COMMAND(ID_FHT_WIN_1, OnFhtWin1)
	ON_COMMAND(ID_FHT_WIN_2, OnFhtWin2)
	ON_COMMAND(ID_FHT_WIN_3, OnFhtWin3)
	ON_COMMAND(ID_FHT_WIN_4, OnFhtWin4)
	ON_COMMAND(ID_FHT_WIN_5, OnFhtWin5)
	ON_COMMAND(ID_FHT_WIN_6, OnFhtWin6)
	ON_COMMAND(ID_FHT_WIN_7, OnFhtWin7)
	ON_COMMAND(ID_FHT_WIN_8, OnFhtWin8)
	ON_COMMAND(ID_FHT_WIN_9, OnFhtWin9)
	ON_COMMAND(ID_FHT_WIN_10, OnFhtWin10)
	ON_COMMAND(ID_FHT_WIN_11, OnFhtWin11)
	ON_COMMAND(ID_FHT_WIN_12, OnFhtWin12)
	ON_COMMAND(ID_FHT_WIN_13, OnFhtWin13)
	ON_UPDATE_COMMAND_UI(ID_FHT_WIN_0, OnUpdateFhtWin0)
	ON_UPDATE_COMMAND_UI(ID_FHT_WIN_1, OnUpdateFhtWin1)
	ON_UPDATE_COMMAND_UI(ID_FHT_WIN_2, OnUpdateFhtWin2)
	ON_UPDATE_COMMAND_UI(ID_FHT_WIN_3, OnUpdateFhtWin3)
	ON_UPDATE_COMMAND_UI(ID_FHT_WIN_4, OnUpdateFhtWin4)
	ON_UPDATE_COMMAND_UI(ID_FHT_WIN_5, OnUpdateFhtWin5)
	ON_UPDATE_COMMAND_UI(ID_FHT_WIN_6, OnUpdateFhtWin6)
	ON_UPDATE_COMMAND_UI(ID_FHT_WIN_7, OnUpdateFhtWin7)
	ON_UPDATE_COMMAND_UI(ID_FHT_WIN_8, OnUpdateFhtWin8)
	ON_UPDATE_COMMAND_UI(ID_FHT_WIN_9, OnUpdateFhtWin9)
	ON_UPDATE_COMMAND_UI(ID_FHT_WIN_10, OnUpdateFhtWin10)
	ON_UPDATE_COMMAND_UI(ID_FHT_WIN_11, OnUpdateFhtWin11)
	ON_UPDATE_COMMAND_UI(ID_FHT_WIN_12, OnUpdateFhtWin12)
	ON_UPDATE_COMMAND_UI(ID_FHT_WIN_13, OnUpdateFhtWin13)
	//
	ON_COMMAND(ID_FILTERS_CH1_UNFILTERED, OnFilterCH1_Unfiltered)
	ON_COMMAND(ID_FILTERS_CH1_LOWPASS, OnFilterCH1_LowPass)
	ON_COMMAND(ID_FILTERS_CH1_HIPASS, OnFilterCH1_HiPass)
	ON_COMMAND(ID_FILTERS_CH2_UNFILTERED, OnFilterCH2_Unfiltered)
	ON_COMMAND(ID_FILTERS_CH2_LOWPASS, OnFilterCH2_LowPass)
	ON_COMMAND(ID_FILTERS_CH2_HIPASS, OnFilterCH2_HiPass)
	ON_COMMAND(ID_FILTERS_POLES_1, OnFiltersPoles_1)
	ON_COMMAND(ID_FILTERS_POLES_2, OnFiltersPoles_2)
	ON_COMMAND(ID_FILTERS_POLES_4, OnFiltersPoles_4)
	ON_COMMAND(ID_FILTERS_POLES_8, OnFiltersPoles_8)
	ON_COMMAND(ID_FILTERS_POLES_16, OnFiltersPoles_16)
	ON_COMMAND(ID_FILTERS_POLES_32, OnFiltersPoles_32)
	//
	ON_UPDATE_COMMAND_UI(ID_FILTERS_CH1_UNFILTERED, OnUpdateFilterCH1_Unfiltered)
	ON_UPDATE_COMMAND_UI(ID_FILTERS_CH1_LOWPASS, OnUpdateFilterCH1_LowPass)
	ON_UPDATE_COMMAND_UI(ID_FILTERS_CH1_HIPASS, OnUpdateFilterCH1_HiPass)
	ON_UPDATE_COMMAND_UI(ID_FILTERS_CH2_UNFILTERED, OnUpdateFilterCH2_Unfiltered)
	ON_UPDATE_COMMAND_UI(ID_FILTERS_CH2_LOWPASS, OnUpdateFilterCH2_LowPass)
	ON_UPDATE_COMMAND_UI(ID_FILTERS_CH1_HIPASS, OnUpdateFilterCH1_HiPass)
	ON_UPDATE_COMMAND_UI(ID_FILTERS_POLES_1, OnUpdateFiltersPoles_1)
	ON_UPDATE_COMMAND_UI(ID_FILTERS_POLES_2, OnUpdateFiltersPoles_2)
	ON_UPDATE_COMMAND_UI(ID_FILTERS_POLES_4, OnUpdateFiltersPoles_4)
	ON_UPDATE_COMMAND_UI(ID_FILTERS_POLES_8, OnUpdateFiltersPoles_8)
	ON_UPDATE_COMMAND_UI(ID_FILTERS_POLES_16, OnUpdateFiltersPoles_16)
	ON_UPDATE_COMMAND_UI(ID_FILTERS_POLES_32, OnUpdateFiltersPoles_32)
	//
	ON_COMMAND(ID_OPEN_MIXERS, OnOpenMixers)
	ON_COMMAND(ID_AUDIO_DEVICES, OnOpenAudioDevices)
	ON_COMMAND(ID_REGISTER_DAA_FILES, OnRegisterDaaFiles)
	ON_COMMAND(ID_REMEMBER_ALL_PROPS, OnRememberAllProps)
	ON_UPDATE_COMMAND_UI(ID_REMEMBER_ALL_PROPS, OnUpdateRememberAllProps)
	//
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)

	ON_COMMAND_RANGE(ID_INPUT_DEVICES_FIRST, ID_INPUT_DEVICES_LAST, OnSetInputDevice)
	ON_COMMAND_RANGE(ID_OUTPUT_DEVICES_FIRST, ID_OUTPUT_DEVICES_LAST, OnSetOutputDevice)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDaaView construction/destruction

CDaaView::CDaaView()
{
	// - TODO: add construction code here

}

CDaaView::~CDaaView()
{
}

BOOL CDaaView::PreCreateWindow(CREATESTRUCT& cs)
{
	// - TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

int CDaaView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;

	SetClassLong (m_hWnd, GCL_HBRBACKGROUND, LONG (HBRUSH (backBrush)));
	                                          
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CDaaView drawing

void CDaaView::OnDraw(CDC* pDC)
{
	DAA_Draw(pDC);
}

/////////////////////////////////////////////////////////////////////////////
// CDaaView printing

BOOL CDaaView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CDaaView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// - TODO: add extra initialization before printing
}

void CDaaView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// - TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CDaaView diagnostics

#ifdef _DEBUG
void CDaaView::AssertValid() const
{
	CView::AssertValid();
}

void CDaaView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CDaaDoc* CDaaView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CDaaDoc)));
	return (CDaaDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDaaView message handlers

void CDaaView::OnSize(UINT nType, int cx, int cy)
{
	CClientDC dc(this);
	DAA_Resize(&dc, nType, cx, cy);
	CView::OnSize(nType, cx, cy);
}

void CDaaView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CClientDC dc(this);
	DAA_LButtonUp(&dc, point);	
	CView::OnLButtonUp(nFlags, point);
}

void CDaaView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CClientDC dc(this);
	DAA_LButtonDown(&dc, point);
	CView::OnLButtonDown(nFlags, point);
}

void CDaaView::OnLButtonDblClk(UINT nFlags, CPoint point)
{
    CClientDC dc(this);
	DAA_LButtonDoubleClick(&dc, point);
    CView::OnLButtonDblClk(nFlags, point);
}

void CDaaView::OnMouseMove(UINT nFlags, CPoint point) 
{
	CClientDC dc(this);
	DAA_MouseMove(&dc, point);
	CView::OnMouseMove(nFlags, point);
}

void CDaaView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CClientDC dc(this);
    DAA_KeyDown(&dc, nChar);
	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}

BOOL CDaaView::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{

	nFlags;		// Buttons and keys pressed
	//zDelta;	// 120 each step
	//pt;		// Screen coords of the cursor

	CClientDC dc(this);
    DAA_MouseWheel(&dc, zDelta, pt);
    return TRUE;
}


// ------------------------------------------------------------------ MENU - VIEW
void CDaaView::OnViewSpectrum3d() 
{
	DAA_ToggleSpectrum3D();
}
void CDaaView::OnUpdateViewSpectrum3d(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetSpectrum3D());
}

void CDaaView::OnViewSetreference() 
{
	DAA_SetReference();
}
void CDaaView::OnUpdateViewSetreference(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetReference());
}

void CDaaView::OnViewMultidraw() 
{
	DAA_ToggleMultiDraw();
}
void CDaaView::OnUpdateViewMultidraw(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetMultiDraw());
}


// ------------------------------------------------------------------ MENU - BANDWIDTH
void CDaaView::OnBwMax() 
{
	DAA_SetBandwidth(0);
}
void CDaaView::OnBw30() 
{
	DAA_SetBandwidth(1);
}

void CDaaView::OnBw10() 
{
	DAA_SetBandwidth(2);
}

void CDaaView::OnBw3() 
{
	DAA_SetBandwidth(3);
}

void CDaaView::OnBw1() 
{
	DAA_SetBandwidth(4);
}

void CDaaView::OnUpdateBwMax(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetBandwidth() == 0); 
}
void CDaaView::OnUpdateBw30(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetBandwidth() == 1);
}
void CDaaView::OnUpdateBw10(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetBandwidth() == 2);
}
void CDaaView::OnUpdateBw3(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetBandwidth() == 3);
}
void CDaaView::OnUpdateBw1(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetBandwidth() == 4);
}


// ------------------------------------------------------------------ MENU - FHT WINDOW
void CDaaView::OnFhtWin0() 
{
	DAA_SetFhtWindow(0);
}
void CDaaView::OnFhtWin1() 
{
	DAA_SetFhtWindow(1);
}
void CDaaView::OnFhtWin2() 
{
	DAA_SetFhtWindow(2);
}
void CDaaView::OnFhtWin3() 
{
	DAA_SetFhtWindow(3);
}
void CDaaView::OnFhtWin4() 
{
	DAA_SetFhtWindow(4);
}
void CDaaView::OnFhtWin5() 
{
	DAA_SetFhtWindow(5);
}
void CDaaView::OnFhtWin6() 
{
	DAA_SetFhtWindow(6);
}
void CDaaView::OnFhtWin7() 
{
	DAA_SetFhtWindow(7);
}
void CDaaView::OnFhtWin8() 
{
	DAA_SetFhtWindow(8);
}
void CDaaView::OnFhtWin9() 
{
	DAA_SetFhtWindow(9);
}
void CDaaView::OnFhtWin10() 
{
	DAA_SetFhtWindow(10);
}
void CDaaView::OnFhtWin11() 
{
	DAA_SetFhtWindow(11);
}
void CDaaView::OnFhtWin12() 
{
	DAA_SetFhtWindow(12);
}
void CDaaView::OnFhtWin13() 
{
	DAA_SetFhtWindow(13);
}

void CDaaView::OnUpdateFhtWin0(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetFhtWindow() == 0); 
}
void CDaaView::OnUpdateFhtWin1(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetFhtWindow() == 1);
}
void CDaaView::OnUpdateFhtWin2(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetFhtWindow() == 2);
}
void CDaaView::OnUpdateFhtWin3(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetFhtWindow() == 3);
}
void CDaaView::OnUpdateFhtWin4(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetFhtWindow() == 4);
}
void CDaaView::OnUpdateFhtWin5(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetFhtWindow() == 5); 
}
void CDaaView::OnUpdateFhtWin6(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetFhtWindow() == 6);
}
void CDaaView::OnUpdateFhtWin7(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetFhtWindow() == 7);
}
void CDaaView::OnUpdateFhtWin8(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetFhtWindow() == 8);
}
void CDaaView::OnUpdateFhtWin9(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetFhtWindow() == 9);
}
void CDaaView::OnUpdateFhtWin10(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetFhtWindow() == 10); 
}
void CDaaView::OnUpdateFhtWin11(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetFhtWindow() == 11);
}
void CDaaView::OnUpdateFhtWin12(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetFhtWindow() == 12);
}
void CDaaView::OnUpdateFhtWin13(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetFhtWindow() == 13);
}


// ------------------------------------------------------------------ MENU - FILTERS
void CDaaView::OnFilterCH1_Unfiltered()
{
	DAA_SetCh1Filter(0);
}
void CDaaView::OnFilterCH1_LowPass()
{
	DAA_SetCh1Filter(1);
}
void CDaaView::OnFilterCH1_HiPass()
{
	DAA_SetCh1Filter(2);
}
void CDaaView::OnFilterCH2_Unfiltered()
{
	DAA_SetCh2Filter(0);
}
void CDaaView::OnFilterCH2_LowPass()
{
	DAA_SetCh2Filter(1);
}
void CDaaView::OnFilterCH2_HiPass()
{
	DAA_SetCh2Filter(2);
}
void CDaaView::OnFiltersPoles_1()
{
	DAA_SetFiltersPoles(1);
}
void CDaaView::OnFiltersPoles_2()
{
	DAA_SetFiltersPoles(2);
}
void CDaaView::OnFiltersPoles_4()
{
	DAA_SetFiltersPoles(4);
}
void CDaaView::OnFiltersPoles_8()
{
	DAA_SetFiltersPoles(8);
}
void CDaaView::OnFiltersPoles_16()
{
	DAA_SetFiltersPoles(16);
}
void CDaaView::OnFiltersPoles_32()
{
	DAA_SetFiltersPoles(32);
}
//
void CDaaView::OnUpdateFilterCH1_Unfiltered(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(DAA_GetCh1Filter() == 0);
}
void CDaaView::OnUpdateFilterCH1_LowPass(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(DAA_GetCh1Filter() == 1);
}
void CDaaView::OnUpdateFilterCH1_HiPass(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(DAA_GetCh1Filter() == 2);
}
void CDaaView::OnUpdateFilterCH2_Unfiltered(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(DAA_GetCh2Filter() == 0);
}
void CDaaView::OnUpdateFilterCH2_LowPass(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(DAA_GetCh2Filter() == 1);
}
void CDaaView::OnUpdateFilterCH2_HiPass(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(DAA_GetCh2Filter() == 2);
}

void CDaaView::OnUpdateFiltersPoles_1(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(DAA_GetFiltersPoles() == 1);
}
void CDaaView::OnUpdateFiltersPoles_2(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(DAA_GetFiltersPoles() == 2);
}
void CDaaView::OnUpdateFiltersPoles_4(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(DAA_GetFiltersPoles() == 4);
}
void CDaaView::OnUpdateFiltersPoles_8(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(DAA_GetFiltersPoles() == 8);
}
void CDaaView::OnUpdateFiltersPoles_16(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(DAA_GetFiltersPoles() == 16);
}
void CDaaView::OnUpdateFiltersPoles_32(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(DAA_GetFiltersPoles() == 32);
}


// ------------------------------------------------------------------ MENU - SETTINGS
void CDaaView::OnOpenMixers()
{
	WinExec("sndvol32.exe",	SW_SHOWNORMAL);
	WinExec("sndvol32.exe /rec", SW_SHOWNORMAL);
	WinExec("sndvol.exe",	SW_SHOWNORMAL);
	WinExec("sndvol.exe /rec", SW_SHOWNORMAL);
}

void CDaaView::OnOpenAudioDevices()
{
	// --------------------- GetVersionEx
	OSVERSIONINFO osvi;
    BOOL IsWindowsVista = false;
	//
    ZeroMemory(&osvi, sizeof(OSVERSIONINFO));
    osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
    GetVersionEx(&osvi);
	if (osvi.dwMajorVersion >= 6) IsWindowsVista = true;
	
	if (IsWindowsVista) WinExec("control mmsys.cpl,,1", SW_SHOWNORMAL);
	else WinExec("control mmsys.cpl,,2", SW_SHOWNORMAL);
}

void CDaaView::OnRegisterDaaFiles()
{
	DAA_RegisterDaaAutoFile();
}

void CDaaView::OnRememberAllProps()
{
	DAA_ToggleRememberAllProps();
}

void CDaaView::OnUpdateRememberAllProps(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(DAA_GetRememberAllProps() != 0);	
}

// ------------------------------------------------------------------ MENU - HELP
void CDaaView::OnHelpHelp() 
{
	// --------------------------------- get application path
	TCHAR szDirectory[MAX_PATH] = "";
	::GetModuleFileName(NULL, szDirectory, sizeof(szDirectory) - 1);
	CString s(szDirectory);
	s = s.Left(s.ReverseFind('\\'));
	// --------------------------------- add "Docs"
	s += "\\Docs";
	// --------------------------------- open Daa.pdf folder
	ShellExecute(NULL, NULL, s, NULL, NULL, SW_SHOW);
}


// ------------------------------------------------------------------ MENU - INPUT OUTPUT DEVICES
void CDaaView::OnSetInputDevice(UINT nID)
{
	DAA_SetInputDevice(nID - ID_INPUT_DEVICES_FIRST);
}
void CDaaView::OnSetOutputDevice(UINT nID)
{
	DAA_SetOutputDevice(nID - ID_OUTPUT_DEVICES_FIRST);
}


